//added 02/03 Michael Re cre1@tampabay.rr.com
//
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace RegexTest
{
  public enum PersistType
  {
    Save,
    Restore
  }

	/// <summary>
	/// Summary description for PersistExpressions.
	/// </summary>
	public class PersistExpressions : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.TextBox txtKeywords;
    private System.Windows.Forms.Button btnOK;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
    private System.Windows.Forms.Button btnCancel;

    private PersistType mptType;
    private string msExpression;
    private string msData;

		internal PersistExpressions()
		{
			InitializeComponent();
      mptType = PersistType.Restore;
      this.Text = "Restore expression";
		}

    public PersistExpressions(string sExpression, string sData)
    {
      InitializeComponent();

      mptType = PersistType.Save;
      this.Text = "Save expression";
      msExpression = sExpression;
      msData = sData;
    }

    private void btnOK_Click(object sender, System.EventArgs e)
    {
      try
      {
        PersistedData pd = new PersistedData();
        if ( mptType == PersistType.Save )
        {
          pd.Save(txtKeywords.Text, msExpression, msData);
        }
        else
        {
          pd.Retrieve(txtKeywords.Text);
          msExpression = pd.Expression;
          msData = pd.Data;
        }
      }
      catch (Exception x)
      {
        MessageBox.Show(x.Message, "Error");
        this.DialogResult = DialogResult.Cancel;
      }
      finally
      {
        this.Close();
      }
    }

    public string Expression
    {
      get { return msExpression; }
    }

    public string Data
    {
      get { return msData; }
    }

    private void btnCancel_Click(object sender, System.EventArgs e)
    {
      this.Close();
    }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.label1 = new System.Windows.Forms.Label();
      this.txtKeywords = new System.Windows.Forms.TextBox();
      this.btnOK = new System.Windows.Forms.Button();
      this.btnCancel = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // label1
      // 
      this.label1.Location = new System.Drawing.Point(10, 8);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(273, 16);
      this.label1.TabIndex = 0;
      this.label1.Text = "Keyword(s) ... case sensitive";
      // 
      // txtKeywords
      // 
      this.txtKeywords.Location = new System.Drawing.Point(4, 29);
      this.txtKeywords.Name = "txtKeywords";
      this.txtKeywords.Size = new System.Drawing.Size(282, 20);
      this.txtKeywords.TabIndex = 1;
      this.txtKeywords.Text = "";
      // 
      // btnOK
      // 
      this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
      this.btnOK.Location = new System.Drawing.Point(175, 59);
      this.btnOK.Name = "btnOK";
      this.btnOK.Size = new System.Drawing.Size(47, 19);
      this.btnOK.TabIndex = 2;
      this.btnOK.Text = "&Ok";
      this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
      // 
      // btnCancel
      // 
      this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
      this.btnCancel.Location = new System.Drawing.Point(240, 59);
      this.btnCancel.Name = "btnCancel";
      this.btnCancel.Size = new System.Drawing.Size(47, 19);
      this.btnCancel.TabIndex = 3;
      this.btnCancel.Text = "&Cancel";
      this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
      // 
      // PersistExpressions
      // 
      this.AcceptButton = this.btnOK;
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.CancelButton = this.btnCancel;
      this.ClientSize = new System.Drawing.Size(292, 86);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.btnCancel,
                                                                  this.btnOK,
                                                                  this.txtKeywords,
                                                                  this.label1});
      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
      this.MaximizeBox = false;
      this.MinimizeBox = false;
      this.Name = "PersistExpressions";
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "PersistExpressions";
      this.ResumeLayout(false);

    }
		#endregion
	}
}
