//added 02/03 Michael Re cre1@tampabay.rr.com
//
using System;
using System.IO;
using System.Xml;
using System.Text;

namespace RegexTest
{
	/// <summary>
	/// Summary description for PersistedData.
	/// </summary>
	public class PersistedData
	{
    const string FILENAME = "PersistedData.xml";
    private XmlDocument moDoc = null;
    private StringBuilder msExpression = new StringBuilder();
    private StringBuilder msData = new StringBuilder();

		public PersistedData()
		{
      moDoc = new XmlDocument();
      moDoc.Load(FILENAME);
    }

    public string Expression
    {
      get { return msExpression.ToString(); }
    }

    public string Data
    {
      get { return msData.ToString(); }
    }

    public void Save(string sKeywords, string sExpression, string sData)
    {
      XmlNode root = moDoc.SelectSingleNode("//root");
      XmlElement data = moDoc.CreateElement(null, "data", null);
      
      XmlElement keyword = moDoc.CreateElement(null, "keyword", null);
      keyword.InnerText = sKeywords;
      data.AppendChild(keyword);

      XmlElement expression = moDoc.CreateElement(null, "expression", null);
      XmlCDataSection CData;
      CData = moDoc.CreateCDataSection(sExpression);    
      expression.AppendChild(CData);
      data.AppendChild(expression);

      XmlElement strings = moDoc.CreateElement(null, "strings", null);
      CData = moDoc.CreateCDataSection(sData);    
      strings.AppendChild(CData);
      data.AppendChild(strings);

      root.AppendChild(data);
      moDoc.Save(FILENAME);
    }

    public void Retrieve(string sKeyword)
    {
      string xpath = "//data/keyword[contains(.,'" + sKeyword + "')]";
      XmlNodeList oList = moDoc.SelectNodes(xpath);
      
      //if we don't find anything, throw exception
      if ( oList.Count == 0 )
        throw new Exception("No matching keywords found!");

      foreach ( XmlNode x in oList )
      {
        XmlNode e = x.NextSibling;
        if ( msExpression.Length == 0 )
          msExpression.Append(e.InnerText);
        else
          msExpression.Append("\r\n\r\n" + e.InnerText);

        XmlNode s = e.NextSibling;
        if ( msData.Length == 0 )
          msData.Append(s.InnerText);
        else
          msData.Append("\r\n\r\n" + s.InnerText);
      }
    }
	}
}
